diff -Naur -X ./exclude vnc_unixsrc.orig/vncviewer/argsresources.c vnc_unixsrc/vncviewer/argsresources.c
--- vnc_unixsrc.orig/vncviewer/argsresources.c	2007-02-04 17:10:31.000000000 -0500
+++ vnc_unixsrc/vncviewer/argsresources.c	2010-04-18 12:39:55.000000000 -0400
@@ -31,9 +31,9 @@
 
 char *fallback_resources[] = {
 
-  "Vncviewer.title: TightVNC: %s",
+  "Ssvnc.title: SSVNC: %s - Press F8 for Menu",
 
-  "Vncviewer.translations:\
+  "Ssvnc.translations:\
     <Enter>: SelectionToVNC()\\n\
     <Leave>: SelectionFromVNC()",
 
@@ -45,8 +45,60 @@
   "*viewport.useRight: True",
   "*viewport*Scrollbar*thumb: None",
 
+           "*viewport.horizontal.height:   6 ",
+              "*viewport.vertical.width:   6 ",
+  "ssvnc*viewport.horizontal.height:   6 ",
+     "ssvnc*viewport.vertical.width:   6 ",
+
+  "*viewport.horizontal.translations: #override\\n\
+     <KeyPress>Right:  StartScroll(Forward)\\n\
+     <KeyRelease>Right:  NotifyScroll(FullLength) EndScroll()\\n\
+     <KeyPress>Left:  StartScroll(Backward)\\n\
+     <KeyRelease>Left:  NotifyScroll(FullLength) EndScroll()\\n\
+     <KeyPress>Next:  StartScroll(Forward)\\n\
+     <KeyRelease>Next:  NotifyScroll(FullLength) EndScroll()\\n\
+     <KeyPress>Prior:  StartScroll(Backward)\\n\
+     <KeyRelease>Prior:  NotifyScroll(FullLength) EndScroll()\\n\
+     <KeyPress>z:  StartScroll(Forward)\\n\
+     <KeyRelease>z:  NotifyScroll(FullLength) EndScroll()\\n\
+     <KeyPress>a:  StartScroll(Backward)\\n\
+     <KeyRelease>a:  NotifyScroll(FullLength) EndScroll()\\n\
+     <KeyPress>f:  StartScroll(Forward)\\n\
+     <KeyRelease>f:  NotifyScroll(FullLength) EndScroll()\\n\
+     <KeyPress>b:  StartScroll(Backward)\\n\
+     <KeyRelease>b:  NotifyScroll(FullLength) EndScroll()\\n\
+     <KeyPress>Down:  StartScroll(Forward)\\n\
+     <KeyRelease>Down:  NotifyScroll(FullLength) EndScroll()\\n\
+     <KeyPress>Up:  StartScroll(Backward)\\n\
+     <KeyRelease>Up:  NotifyScroll(FullLength) EndScroll()",
+
+  "*viewport.vertical.translations: #override\\n\
+     <KeyPress>Down:  StartScroll(Forward)\\n\
+     <KeyRelease>Down:  NotifyScroll(FullLength) EndScroll()\\n\
+     <KeyPress>Up:  StartScroll(Backward)\\n\
+     <KeyRelease>Up:  NotifyScroll(FullLength) EndScroll()\\n\
+     <KeyPress>Next:  StartScroll(Forward)\\n\
+     <KeyRelease>Next:  NotifyScroll(FullLength) EndScroll()\\n\
+     <KeyPress>Prior:  StartScroll(Backward)\\n\
+     <KeyRelease>Prior:  NotifyScroll(FullLength) EndScroll()\\n\
+     <KeyPress>z:  StartScroll(Forward)\\n\
+     <KeyRelease>z:  NotifyScroll(FullLength) EndScroll()\\n\
+     <KeyPress>a:  StartScroll(Backward)\\n\
+     <KeyRelease>a:  NotifyScroll(FullLength) EndScroll()\\n\
+     <KeyPress>f:  StartScroll(Forward)\\n\
+     <KeyRelease>f:  NotifyScroll(FullLength) EndScroll()\\n\
+     <KeyPress>b:  StartScroll(Backward)\\n\
+     <KeyRelease>b:  NotifyScroll(FullLength) EndScroll()\\n\
+     <KeyPress>Right:  StartScroll(Forward)\\n\
+     <KeyRelease>Right:  NotifyScroll(FullLength) EndScroll()\\n\
+     <KeyPress>Left:  StartScroll(Backward)\\n\
+     <KeyRelease>Left:  NotifyScroll(FullLength) EndScroll()",
+
   "*desktop.baseTranslations:\
-     <Key>F8: ShowPopup()\\n\
+     <KeyPress>F8:  ShowPopup()\\n\
+     <KeyRelease>F8:  Noop()\\n\
+     <KeyPress>F9:  ToggleFullScreen()\\n\
+     <KeyRelease>F9:  Noop()\\n\
      <ButtonPress>: SendRFBEvent()\\n\
      <ButtonRelease>: SendRFBEvent()\\n\
      <Motion>: SendRFBEvent()\\n\
@@ -55,26 +107,137 @@
 
   "*serverDialog.dialog.label: VNC server:",
   "*serverDialog.dialog.value:",
+  "*serverDialog.dialog.value.width: 150",
   "*serverDialog.dialog.value.translations: #override\\n\
      <Key>Return: ServerDialogDone()",
 
-  "*passwordDialog.dialog.label: Password:",
+  "*userDialog.dialog.label: SSVNC: Enter Username",
+  "*userDialog.dialog.value:",
+  "*userDialog.dialog.value.width: 150",
+  "*userDialog.dialog.value.translations: #override\\n\
+     <Key>Return: UserDialogDone()",
+
+  "*scaleDialog.dialog.label: Scale: Enter 'none' (same as '1' or '1.0'),\\na geometry WxH (e.g. 1280x1024), or\\na fraction (e.g. 0.75 or 3/4).\\nUse 'fit' for full screen size.\\nUse 'auto' to match window size.\\nCurrent value:",
+  "*scaleDialog.dialog.value:",
+  "*scaleDialog.dialog.value.translations: #override\\n\
+     <KeyRelease>Return: ScaleDialogDone()",
+
+  "*escapeDialog.dialog.label: Escape Keys:  Enter a comma separated list of modifier keys to be the\\n"
+                              "'escape sequence'.  When these keys are held down, the next keystroke is\\n"
+                              "interpreted locally to invoke a special action instead of being sent to\\n"
+                              "the remote VNC server.  In other words, a set of 'Hot Keys'.\\n"
+                              "\\n"
+                              "To enable or disable this, click on 'Escape Keys: Toggle' in the Popup.\\n"
+                              "\\n"
+                              "Here is the list of hot-key mappings to special actions:\\n"
+                              "\\n"
+                              "   r: refresh desktop  b: toggle bell   c: toggle full-color\\n"
+                              "   f: file transfer    x: x11cursor     z: toggle Tight/ZRLE\\n"
+                              "   l: full screen      g: graball       e: escape keys dialog\\n"
+                              "   s: scale dialog     +: scale up (=)  -: scale down (_)\\n"
+                              "   t: text chat                         a: alphablend cursor\\n"
+                              "   V: toggle viewonly  Q: quit viewer   1 2 3 4 5 6: UltraVNC scale 1/n\\n"
+                              "\\n"
+                              "   Arrow keys:         pan the viewport about 10% for each keypress.\\n"
+                              "   PageUp / PageDown:  pan the viewport by a screenful vertically.\\n"
+                              "   Home   / End:       pan the viewport by a screenful horizontally.\\n"
+                              "   KeyPad Arrow keys:  pan the viewport by 1 pixel for each keypress.\\n"
+                              "   Dragging the Mouse with Button1 pressed also pans the viewport.\\n"
+                              "   Clicking Mouse Button3 brings up the Popup Menu.\\n"
+                              "\\n"
+                              "The above mappings are *always* active in ViewOnly mode, unless you set the\\n"
+                              "Escape Keys value to 'never'.\\n"
+                              "\\n"
+                              "x11vnc -appshare hot-keys:  x11vnc has a simple application sharing mode\\n"
+                              "that enables the viewer-side to move, resize, or raise the remote toplevel\\n"
+                              "windows.  To enable it, hold down Shift + the Escape Keys and press these:\\n"
+                              "\\n"
+                              "   Arrow keys:              move the remote window around in its desktop.\\n"
+                              "   PageUp/PageDn/Home/End:  resize the remote window.\\n"
+                              "   +/-                      raise or lower the remote window.\\n"
+                              "   M or Button1 move win to local position;  D or Button3: delete remote win.\\n"
+                              "\\n"
+                              "If the Escape Keys value below is set to 'default' then a fixed list of\\n"
+                              "modifier keys is used.  For Unix it is: Alt_L,Super_L and for MacOSX it is\\n"
+                              "Control_L,Meta_L.  Note: the Super_L key usually has a Windows(TM) Flag.\\n"
+                              "Also note the _L and _R mean the key is on the LEFT or RIGHT side of keyboard.\\n"
+                              "\\n"
+                              "On Unix   the default is Alt and Windows keys on Left side of keyboard.\\n"
+                              "On MacOSX the default is Control and Command keys on Left side of keyboard.\\n"
+                              "\\n"
+                              "Example: Press and hold the Alt and Windows keys on the LEFT side of the\\n"
+                              "keyboard and then press 'c' to toggle the full-color state.  Or press 't'\\n"
+                              "to toggle the ultravnc Text Chat window, etc.\\n"
+                              "\\n"
+                              "To use something besides the default, supply a comma separated list (or a\\n"
+                              "single one) from: Shift_L Shift_R Control_L Control_R Alt_L Alt_R Meta_L\\n"
+                              "Meta_R Super_L Super_R Hyper_L Hyper_R or Mode_switch.\\n"
+                              "\\n"
+                              "Current Escape Keys Value:",
+  "*escapeDialog.dialog.value:",
+  "*escapeDialog.dialog.value.width: 280",
+  "*escapeDialog.dialog.value.translations: #override\\n\
+     <KeyRelease>Return: EscapeDialogDone()",
+
+  "*ycropDialog.dialog.label: Y Crop (max-height in pixels):",
+  "*ycropDialog.dialog.value:",
+  "*ycropDialog.dialog.value.translations: #override\\n\
+     <KeyRelease>Return: YCropDialogDone()",
+
+  "*scbarDialog.dialog.label: Scroll Bars width:",
+  "*scbarDialog.dialog.value:",
+  "*scbarDialog.dialog.value.translations: #override\\n\
+     <KeyRelease>Return: ScbarDialogDone()",
+
+  "*scaleNDialog.dialog.label: Integer n for 1/n server scaling:",
+  "*scaleNDialog.dialog.value:",
+  "*scaleNDialog.dialog.value.translations: #override\\n\
+     <KeyRelease>Return: ScaleNDialogDone()",
+
+  "*passwordDialog.dialog.label: SSVNC: Enter Password",
   "*passwordDialog.dialog.value:",
+  "*passwordDialog.dialog.value.width: 150",
   "*passwordDialog.dialog.value.AsciiSink.echo: False",
   "*passwordDialog.dialog.value.translations: #override\\n\
      <Key>Return: PasswordDialogDone()",
 
-  "*popup.title: TightVNC popup",
+  "*popup.title: SSVNC popup",
   "*popup*background: grey",
-  "*popup*font: -*-helvetica-bold-r-*-*-16-*-*-*-*-*-*-*",
-  "*popup.buttonForm.Command.borderWidth: 0",
-  "*popup.buttonForm.Toggle.borderWidth: 0",
+  "*popup*font_old: -*-helvetica-bold-r-*-*-16-*-*-*-*-*-*-*",
+  "*popup*font: -*-helvetica-medium-r-*-*-12-*-*-*-*-*-*-*",
+  "*popup.buttonForm*.Command.borderWidth: 0",
+  "*popup.buttonForm*.Toggle.borderWidth: 0",
+
+  "*scaleN.title: 1/n scale",
+  "*scaleN*background: grey",
+  "*scaleN*font: -*-helvetica-medium-r-*-*-12-*-*-*-*-*-*-*",
+  "*scaleN.buttonForm.Command.borderWidth: 0",
+  "*scaleN.buttonForm.Toggle.borderWidth: 0",
+
+  "*turboVNC.title: TurboVNC",
+  "*turboVNC*background: grey",
+  "*turboVNC*font: -*-helvetica-medium-r-*-*-12-*-*-*-*-*-*-*",
+  "*turboVNC.buttonForm.Command.borderWidth: 0",
+  "*turboVNC.buttonForm.Toggle.borderWidth: 0",
+
+  "*quality.title: quality",
+  "*quality*background: grey",
+  "*quality*font: -*-helvetica-medium-r-*-*-12-*-*-*-*-*-*-*",
+  "*quality.buttonForm.Command.borderWidth: 0",
+  "*quality.buttonForm.Toggle.borderWidth: 0",
+
+  "*compress.title: compress",
+  "*compress*background: grey",
+  "*compress*font: -*-helvetica-medium-r-*-*-12-*-*-*-*-*-*-*",
+  "*compress.buttonForm.Command.borderWidth: 0",
+  "*compress.buttonForm.Toggle.borderWidth: 0",
 
   "*popup.translations: #override <Message>WM_PROTOCOLS: HidePopup()",
   "*popup.buttonForm.translations: #override\\n\
      <KeyPress>: SendRFBEvent() HidePopup()",
 
-  "*popupButtonCount: 8",
+  "*popupButtonCount: 44",
+  "*popupButtonBreak: 22",
 
   "*popup*button1.label: Dismiss popup",
   "*popup*button1.translations: #override\\n\
@@ -84,7 +247,7 @@
   "*popup*button2.translations: #override\\n\
      <Btn1Down>,<Btn1Up>: Quit()",
 
-  "*popup*button3.label: Full screen",
+  "*popup*button3.label: Full screen  (also F9)",
   "*popup*button3.type: toggle",
   "*popup*button3.translations: #override\\n\
      <Visible>: SetFullScreenState()\\n\
@@ -105,16 +268,426 @@
   "*popup*button7.label: Send ctrl-alt-del",
   "*popup*button7.translations: #override\\n\
      <Btn1Down>,<Btn1Up>: SendRFBEvent(keydown,Control_L)\
-                          SendRFBEvent(keydown,Alt_L)\
-                          SendRFBEvent(key,Delete)\
-                          SendRFBEvent(keyup,Alt_L)\
-                          SendRFBEvent(keyup,Control_L)\
-                          HidePopup()",
+     SendRFBEvent(keydown,Alt_L)\
+     SendRFBEvent(key,Delete)\
+     SendRFBEvent(keyup,Alt_L)\
+     SendRFBEvent(keyup,Control_L)\
+     HidePopup()",
 
   "*popup*button8.label: Send F8",
   "*popup*button8.translations: #override\\n\
      <Btn1Down>,<Btn1Up>: SendRFBEvent(key,F8) HidePopup()",
 
+  "*popup*button9.label: Send F9",
+  "*popup*button9.translations: #override\\n\
+     <Btn1Down>,<Btn1Up>: SendRFBEvent(key,F9) HidePopup()",
+
+  "*popup*button10.label: ViewOnly",
+  "*popup*button10.type: toggle",
+  "*popup*button10.translations: #override\\n\
+     <Visible>: SetViewOnlyState()\\n\
+     <Btn1Down>,<Btn1Up>: toggle() ToggleViewOnly() HidePopup()",
+
+  "*popup*button11.label: Disable Bell",
+  "*popup*button11.type: toggle",
+  "*popup*button11.translations: #override\\n\
+     <Visible>: SetBellState()\\n\
+     <Btn1Down>,<Btn1Up>: toggle() ToggleBell() HidePopup()",
+
+  "*popup*button12.label: Cursor Shape",
+  "*popup*button12.type: toggle",
+  "*popup*button12.translations: #override\\n\
+     <Visible>: SetCursorShapeState()\\n\
+     <Btn1Down>,<Btn1Up>: toggle() ToggleCursorShape() HidePopup()",
+
+  "*popup*button13.label: X11 Cursor",
+  "*popup*button13.type: toggle",
+  "*popup*button13.translations: #override\\n\
+     <Visible>: SetX11CursorState()\\n\
+     <Btn1Down>,<Btn1Up>: toggle() ToggleX11Cursor() HidePopup()",
+
+  "*popup*button14.label: Cursor Alphablend",
+  "*popup*button14.type: toggle",
+  "*popup*button14.translations: #override\\n\
+     <Visible>: SetCursorAlphaState()\\n\
+     <Btn1Down>,<Btn1Up>: toggle() ToggleCursorAlpha() HidePopup()",
+
+  "*popup*button15.label: Toggle Tight/Hextile",
+  "*popup*button15.type: toggle",
+  "*popup*button15.translations: #override\\n\
+     <Visible>: SetHextileState()\\n\
+     <Btn1Down>,<Btn1Up>: toggle() ToggleTightHextile() HidePopup()",
+
+  "*popup*button16.label: Toggle Tight/ZRLE",
+  "*popup*button16.type: toggle",
+  "*popup*button16.translations: #override\\n\
+     <Visible>: SetZRLEState()\\n\
+     <Btn1Down>,<Btn1Up>: toggle() ToggleTightZRLE() HidePopup()",
+
+  "*popup*button17.label: Toggle ZRLE/ZYWRLE",
+  "*popup*button17.type: toggle",
+  "*popup*button17.translations: #override\\n\
+     <Visible>: SetZYWRLEState()\\n\
+     <Btn1Down>,<Btn1Up>: toggle() ToggleZRLEZYWRLE() HidePopup()",
+
+  "*popup*button18.label: Quality Level",
+  "*popup*button18.translations: #override\\n\
+     <Btn1Down>,<Btn1Up>: HidePopup() ShowQuality()",
+
+  "*popup*button19.label: Compress Level",
+  "*popup*button19.translations: #override\\n\
+     <Btn1Down>,<Btn1Up>: HidePopup() ShowCompress()",
+
+  "*popup*button20.label: Disable JPEG",
+  "*popup*button20.type: toggle",
+  "*popup*button20.translations: #override\\n\
+     <Visible>: SetNOJPEGState()\\n\
+     <Btn1Down>,<Btn1Up>: toggle() ToggleJPEG() HidePopup()",
+
+  "*popup*button21.label: TurboVNC Settings",
+  "*popup*button21.translations: #override\\n\
+     <Btn1Down>,<Btn1Up>: HidePopup() ShowTurboVNC()",
+
+  "*popup*button22.label: Pipeline Updates",
+  "*popup*button22.type: toggle",
+  "*popup*button22.translations: #override\\n\
+     <Visible>: SetPipelineUpdates()\\n\
+     <Btn1Down>,<Btn1Up>: toggle() TogglePipelineUpdates() HidePopup()",
+
+  "*popup*button23.label: Full Color",
+  "*popup*button23.type: toggle",
+  "*popup*button23.translations: #override\\n\
+     <Visible>: SetFullColorState()\\n\
+     <Btn1Down>,<Btn1Up>: toggle() ToggleFullColor() HidePopup()",
+
+  "*popup*button24.label: Grey Scale (16 & 8-bpp)",
+  "*popup*button24.type: toggle",
+  "*popup*button24.translations: #override\\n\
+     <Visible>: SetGreyScaleState()\\n\
+     <Btn1Down>,<Btn1Up>: toggle() ToggleGreyScale() HidePopup()",
+
+  "*popup*button25.label: 16 bit color (BGR565)",
+  "*popup*button25.type: toggle",
+  "*popup*button25.translations: #override\\n\
+     <Visible>: Set16bppState()\\n\
+     <Btn1Down>,<Btn1Up>: toggle() Toggle16bpp() HidePopup()",
+
+  "*popup*button26.label: 8   bit color (BGR233)",
+  "*popup*button26.type: toggle",
+  "*popup*button26.translations: #override\\n\
+     <Visible>: Set8bppState()\\n\
+     <Btn1Down>,<Btn1Up>: toggle() Toggle8bpp() HidePopup()",
+
+  "*popup*button27.label: -     256 colors",
+  "*popup*button27.type: toggle",
+  "*popup*button27.translations: #override\\n\
+     <Visible>: Set256ColorsState()\\n\
+     <Btn1Down>,<Btn1Up>: toggle() Toggle256Colors() HidePopup()",
+
+  "*popup*button28.label: -       64 colors",
+  "*popup*button28.type: toggle",
+  "*popup*button28.translations: #override\\n\
+     <Visible>: Set64ColorsState()\\n\
+     <Btn1Down>,<Btn1Up>: toggle() Toggle64Colors() HidePopup()",
+
+  "*popup*button29.label: -         8 colors",
+  "*popup*button29.type: toggle",
+  "*popup*button29.translations: #override\\n\
+     <Visible>: Set8ColorsState()\\n\
+     <Btn1Down>,<Btn1Up>: toggle() Toggle8Colors() HidePopup()",
+
+  "*popup*button30.label: Scale Viewer",
+  "*popup*button30.translations: #override\\n\
+     <Btn1Down>,<Btn1Up>: HidePopup() SetScale()",
+
+  "*popup*button31.label: Escape Keys: Toggle",
+  "*popup*button31.type: toggle",
+  "*popup*button31.translations: #override\\n\
+     <Visible>: SetEscapeKeysState()\\n\
+     <Btn1Down>, <Btn1Up>: toggle() ToggleEscapeActive() HidePopup()",
+
+  "*popup*button32.label: Escape Keys: Help+Set",
+  "*popup*button32.translations: #override\\n\
+      <Btn1Down>, <Btn1Up>: HidePopup() SetEscapeKeys()",
+
+  "*popup*button33.label: Set Y Crop (y-max)",
+  "*popup*button33.translations: #override\\n\
+     <Btn1Down>,<Btn1Up>: HidePopup() SetYCrop()",
+
+  "*popup*button34.label: Set Scrollbar Width",
+  "*popup*button34.translations: #override\\n\
+     <Btn1Down>,<Btn1Up>: HidePopup() SetScbar()",
+
+  "*popup*button35.label: XGrabServer",
+  "*popup*button35.type: toggle",
+  "*popup*button35.translations: #override\\n\
+     <Visible>: SetXGrabState()\\n\
+     <Btn1Down>,<Btn1Up>: toggle() ToggleXGrab() HidePopup()",
+
+  "*popup*button36.label: UltraVNC Extensions:",
+  "*popup*button36.translations: #override\\n\
+     <Btn1Down>,<Btn1Up>: HidePopup()",
+
+  "*popup*button37.label: - Set 1/n Server Scale",
+  "*popup*button37.translations: #override\\n\
+     <Btn1Down>,<Btn1Up>: HidePopup() ShowScaleN()",
+
+  "*popup*button38.label: - Text Chat",
+  "*popup*button38.type: toggle",
+  "*popup*button38.translations: #override\\n\
+     <Visible>: SetTextChatState()\\n\
+     <Btn1Down>,<Btn1Up>: toggle() ToggleTextChat() HidePopup()",
+
+  "*popup*button39.label: - File Transfer",
+  "*popup*button39.type: toggle",
+  "*popup*button39.translations: #override\\n\
+     <Visible>: SetFileXferState()\\n\
+     <Btn1Down>,<Btn1Up>: toggle() ToggleFileXfer() HidePopup()",
+
+  "*popup*button40.label: - Single Window",
+  "*popup*button40.type: toggle",
+  "*popup*button40.translations: #override\\n\
+     <Visible>: SetSingleWindowState()\\n\
+     <Btn1Down>,<Btn1Up>: toggle() ToggleSingleWindow() HidePopup()",
+
+  "*popup*button41.label: - Disable Remote Input",
+  "*popup*button41.type: toggle",
+  "*popup*button41.translations: #override\\n\
+     <Visible>: SetServerInputState()\\n\
+     <Btn1Down>,<Btn1Up>: toggle() ToggleServerInput() HidePopup()",
+
+  "*popup*button42.label: Send Clipboard not Primary",
+  "*popup*button42.type: toggle",
+  "*popup*button42.translations: #override\\n\
+     <Visible>: SetSendClipboard()\\n\
+     <Btn1Down>,<Btn1Up>: toggle() ToggleSendClipboard() HidePopup()",
+
+  "*popup*button43.label: Send Selection Every time",
+  "*popup*button43.type: toggle",
+  "*popup*button43.translations: #override\\n\
+     <Visible>: SetSendAlways()\\n\
+     <Btn1Down>,<Btn1Up>: toggle() ToggleSendAlways() HidePopup()",
+
+  "*popup*button44.label: ",
+
+  "*turboVNC*button0.label: Dismiss",
+  "*turboVNC*button0.translations: #override\\n\
+     <Btn1Down>,<Btn1Up>: HideTurboVNC()",
+
+  "*turboVNC*button1.label: High Quality (LAN)",
+  "*turboVNC*button1.translations: #override\\n\
+     <Btn1Down>,<Btn1Up>: SetTurboVNC(1)",
+
+  "*turboVNC*button2.label: Medium Quality",
+  "*turboVNC*button2.translations: #override\\n\
+     <Btn1Down>,<Btn1Up>: SetTurboVNC(2)",
+
+  "*turboVNC*button3.label: Low Quality (WAN)",
+  "*turboVNC*button3.translations: #override\\n\
+     <Btn1Down>,<Btn1Up>: SetTurboVNC(3)",
+
+  "*turboVNC*button4.label: Lossless (Gigabit)",
+  "*turboVNC*button4.translations: #override\\n\
+     <Btn1Down>,<Btn1Up>: SetTurboVNC(4)",
+
+  "*turboVNC*button5.label: Lossless Zlib (WAN)",
+  "*turboVNC*button5.translations: #override\\n\
+     <Btn1Down>,<Btn1Up>: SetTurboVNC(5)",
+
+  "*turboVNC*button6.label: Subsampling:",
+
+  "*turboVNC*button7.label: -           None",
+  "*turboVNC*button7.translations: #override\\n\
+     <Btn1Down>,<Btn1Up>: SetTurboVNC(6)",
+
+  "*turboVNC*button8.label: -           2X",
+  "*turboVNC*button8.translations: #override\\n\
+     <Btn1Down>,<Btn1Up>: SetTurboVNC(7)",
+
+  "*turboVNC*button9.label: -           4X",
+  "*turboVNC*button9.translations: #override\\n\
+     <Btn1Down>,<Btn1Up>: SetTurboVNC(8)",
+
+  "*turboVNC*button10.label: -          Gray",
+  "*turboVNC*button10.translations: #override\\n\
+     <Btn1Down>,<Btn1Up>: SetTurboVNC(9)",
+
+  "*turboVNC*button11.label: Lossless Refresh",
+  "*turboVNC*button11.translations: #override\\n\
+     <Btn1Down>,<Btn1Up>: SetTurboVNC(10)",
+
+  "*turboVNC*button12.label: Lossy Refresh",
+  "*turboVNC*button12.translations: #override\\n\
+     <Btn1Down>,<Btn1Up>: SendRFBEvent(fbupdate)",
+
+  "*turboVNC*buttonNone.label: Not Compiled with\\nTurboVNC Support.",
+  "*turboVNC*buttonNone.translations: #override\\n\
+     <Btn1Down>,<Btn1Up>: HideTurboVNC()",
+
+  "*qualLabel.label: JPEG Image Quality:",
+  "*qualBar.length: 100",
+  "*qualBar.width: 130",
+  "*qualBar.orientation: horizontal",
+  "*qualBar.translations: #override\\n\
+     <Btn1Down>: StartScroll(Continuous) MoveThumb() NotifyThumb()\\n\
+     <Btn1Motion>: MoveThumb() NotifyThumb()\\n\
+     <Btn3Down>: StartScroll(Continuous) MoveThumb() NotifyThumb()\\n\
+     <Btn3Motion>: MoveThumb() NotifyThumb()",
+    
+  "*qualText.label: 000",
+
+  "*scaleN*button0.label: Dismiss",
+  "*scaleN*button0.translations: #override\\n\
+     <Btn1Down>,<Btn1Up>: HideScaleN()",
+
+  "*scaleN*button1.label: 1/1",
+  "*scaleN*button1.translations: #override\\n\
+     <Visible>: SetScaleNState(1)\\n\
+     <Btn1Down>,<Btn1Up>: SetScaleN(1) HideScaleN()",
+
+  "*scaleN*button2.label: 1/2",
+  "*scaleN*button2.translations: #override\\n\
+     <Visible>: SetScaleNState(2)\\n\
+     <Btn1Down>,<Btn1Up>: SetScaleN(2) HideScaleN()",
+
+  "*scaleN*button3.label: 1/3",
+  "*scaleN*button3.translations: #override\\n\
+     <Visible>: SetScaleNState(3)\\n\
+     <Btn1Down>,<Btn1Up>: SetScaleN(3) HideScaleN()",
+
+  "*scaleN*button4.label: 1/4",
+  "*scaleN*button4.translations: #override\\n\
+     <Visible>: SetScaleNState(4)\\n\
+     <Btn1Down>,<Btn1Up>: SetScaleN(4) HideScaleN()",
+
+  "*scaleN*button5.label: 1/5",
+  "*scaleN*button5.translations: #override\\n\
+     <Visible>: SetScaleNState(5)\\n\
+     <Btn1Down>,<Btn1Up>: SetScaleN(5) HideScaleN()",
+
+  "*scaleN*button6.label: Other",
+  "*scaleN*button6.translations: #override\\n\
+     <Visible>: SetScaleNState(6)\\n\
+     <Btn1Down>,<Btn1Up>: HideScaleN() DoServerScale()",
+
+  "*quality*buttonD.label: Dismiss",
+  "*quality*buttonD.translations: #override\\n\
+     <Btn1Down>,<Btn1Up>: HideQuality()",
+
+  "*quality*button0.label: 0",
+  "*quality*button0.type: toggle",
+  "*quality*button0.translations: #override\\n\
+     <Visible>: SetQualityState(0)\\n\
+     <Btn1Down>,<Btn1Up>: SetQuality(0) HideQuality()",
+
+  "*quality*button1.label: 1",
+  "*quality*button1.type: toggle",
+  "*quality*button1.translations: #override\\n\
+     <Visible>: SetQualityState(1)\\n\
+     <Btn1Down>,<Btn1Up>: SetQuality(1) HideQuality()",
+
+  "*quality*button2.label: 2",
+  "*quality*button2.type: toggle",
+  "*quality*button2.translations: #override\\n\
+     <Visible>: SetQualityState(2)\\n\
+     <Btn1Down>,<Btn1Up>: SetQuality(2) HideQuality()",
+
+  "*quality*button3.label: 3",
+  "*quality*button3.type: toggle",
+  "*quality*button3.translations: #override\\n\
+     <Visible>: SetQualityState(3)\\n\
+     <Btn1Down>,<Btn1Up>: SetQuality(3) HideQuality()",
+
+  "*quality*button4.label: 4",
+  "*quality*button4.type: toggle",
+  "*quality*button4.translations: #override\\n\
+     <Visible>: SetQualityState(4)\\n\
+     <Btn1Down>,<Btn1Up>: SetQuality(4) HideQuality()",
+
+  "*quality*button5.label: 5",
+  "*quality*button5.type: toggle",
+  "*quality*button5.translations: #override\\n\
+     <Visible>: SetQualityState(5)\\n\
+     <Btn1Down>,<Btn1Up>: SetQuality(5) HideQuality()",
+
+  "*quality*button6.label: 6",
+  "*quality*button6.type: toggle",
+  "*quality*button6.translations: #override\\n\
+     <Visible>: SetQualityState(6)\\n\
+     <Btn1Down>,<Btn1Up>: SetQuality(6) HideQuality()",
+
+  "*quality*button7.label: 7",
+  "*quality*button7.type: toggle",
+  "*quality*button7.translations: #override\\n\
+     <Visible>: SetQualityState(7)\\n\
+     <Btn1Down>,<Btn1Up>: SetQuality(7) HideQuality()",
+
+  "*quality*button8.label: 8",
+  "*quality*button8.type: toggle",
+  "*quality*button8.translations: #override\\n\
+     <Visible>: SetQualityState(8)\\n\
+     <Btn1Down>,<Btn1Up>: SetQuality(8) HideQuality()",
+
+  "*quality*button9.label: 9",
+  "*quality*button9.type: toggle",
+  "*quality*button9.translations: #override\\n\
+     <Visible>: SetQualityState(9)\\n\
+     <Btn1Down>,<Btn1Up>: SetQuality(9) HideQuality()",
+
+  "*compress*buttonD.label: Dismiss",
+  "*compress*buttonD.translations: #override\\n\
+     <Btn1Down>,<Btn1Up>: HideCompress()",
+
+  "*compress*button0.label: 0",
+  "*compress*button0.translations: #override\\n\
+     <Visible>: SetCompressState(0)\\n\
+     <Btn1Down>,<Btn1Up>: SetCompress(0) HideCompress()",
+
+  "*compress*button1.label: 1",
+  "*compress*button1.translations: #override\\n\
+     <Visible>: SetCompressState(1)\\n\
+     <Btn1Down>,<Btn1Up>: SetCompress(1) HideCompress()",
+
+  "*compress*button2.label: 2",
+  "*compress*button2.translations: #override\\n\
+     <Visible>: SetCompressState(2)\\n\
+     <Btn1Down>,<Btn1Up>: SetCompress(2) HideCompress()",
+
+  "*compress*button3.label: 3",
+  "*compress*button3.translations: #override\\n\
+     <Visible>: SetCompressState(3)\\n\
+     <Btn1Down>,<Btn1Up>: SetCompress(3) HideCompress()",
+
+  "*compress*button4.label: 4",
+  "*compress*button4.translations: #override\\n\
+     <Visible>: SetCompressState(4)\\n\
+     <Btn1Down>,<Btn1Up>: SetCompress(4) HideCompress()",
+
+  "*compress*button5.label: 5",
+  "*compress*button5.translations: #override\\n\
+     <Visible>: SetCompressState(5)\\n\
+     <Btn1Down>,<Btn1Up>: SetCompress(5) HideCompress()",
+
+  "*compress*button6.label: 6",
+  "*compress*button6.translations: #override\\n\
+     <Visible>: SetCompressState(6)\\n\
+     <Btn1Down>,<Btn1Up>: SetCompress(6) HideCompress()",
+
+  "*compress*button7.label: 7",
+  "*compress*button7.translations: #override\\n\
+     <Visible>: SetCompressState(7)\\n\
+     <Btn1Down>,<Btn1Up>: SetCompress(7) HideCompress()",
+
+  "*compress*button8.label: 8",
+  "*compress*button8.translations: #override\\n\
+     <Visible>: SetCompressState(8)\\n\
+     <Btn1Down>,<Btn1Up>: SetCompress(8) HideCompress()",
+
+  "*compress*button9.label: 9",
+  "*compress*button9.translations: #override\\n\
+     <Visible>: SetCompressState(9)\\n\
+     <Btn1Down>,<Btn1Up>: SetCompress(9) HideCompress()",
+
   NULL
 };
 
@@ -124,7 +697,7 @@
  * from a dialog box.
  */
 
-char vncServerHost[256];
+char vncServerHost[1024];
 int vncServerPort = 0;
 
 
@@ -135,6 +708,7 @@
  */
 
 AppData appData;
+AppData appDataNew;
 
 static XtResource appDataResourceList[] = {
   {"shareDesktop", "ShareDesktop", XtRBool, sizeof(Bool),
@@ -155,14 +729,44 @@
   {"userLogin", "UserLogin", XtRString, sizeof(String),
    XtOffsetOf(AppData, userLogin), XtRImmediate, (XtPointer) 0},
 
+  {"unixPW", "UnixPW", XtRString, sizeof(String),
+   XtOffsetOf(AppData, unixPW), XtRImmediate, (XtPointer) 0},
+
+  {"msLogon", "MSLogon", XtRString, sizeof(String),
+   XtOffsetOf(AppData, msLogon), XtRImmediate, (XtPointer) 0},
+
+  {"repeaterUltra", "RepeaterUltra", XtRString, sizeof(String),
+   XtOffsetOf(AppData, repeaterUltra), XtRImmediate, (XtPointer) 0},
+
+  {"ultraDSM", "UltraDSM", XtRBool, sizeof(Bool),
+   XtOffsetOf(AppData, ultraDSM), XtRImmediate, (XtPointer) False},
+
+  {"acceptPopup", "AcceptPopup", XtRBool, sizeof(Bool),
+   XtOffsetOf(AppData, acceptPopup), XtRImmediate, (XtPointer) False},
+
+  {"rfbVersion", "RfbVersion", XtRString, sizeof(String),
+   XtOffsetOf(AppData, rfbVersion), XtRImmediate, (XtPointer) 0},
+
   {"passwordDialog", "PasswordDialog", XtRBool, sizeof(Bool),
    XtOffsetOf(AppData, passwordDialog), XtRImmediate, (XtPointer) False},
 
   {"encodings", "Encodings", XtRString, sizeof(String),
    XtOffsetOf(AppData, encodingsString), XtRImmediate, (XtPointer) 0},
 
-  {"useBGR233", "UseBGR233", XtRBool, sizeof(Bool),
-   XtOffsetOf(AppData, useBGR233), XtRImmediate, (XtPointer) False},
+  {"useBGR233", "UseBGR233", XtRInt, sizeof(int),
+   XtOffsetOf(AppData, useBGR233), XtRImmediate, (XtPointer) 0},
+
+  {"useBGR565", "UseBGR565", XtRBool, sizeof(Bool),
+   XtOffsetOf(AppData, useBGR565), XtRImmediate, (XtPointer) False},
+
+  {"useGreyScale", "UseGreyScale", XtRBool, sizeof(Bool),
+   XtOffsetOf(AppData, useGreyScale), XtRImmediate, (XtPointer) False},
+
+  {"yCrop", "yCrop", XtRInt, sizeof(int),
+   XtOffsetOf(AppData, yCrop), XtRImmediate, (XtPointer) 0},
+
+  {"sbWidth", "sbWidth", XtRInt, sizeof(int),
+   XtOffsetOf(AppData, sbWidth), XtRImmediate, (XtPointer) 2},
 
   {"nColours", "NColours", XtRInt, sizeof(int),
    XtOffsetOf(AppData, nColours), XtRImmediate, (XtPointer) 256},
@@ -179,9 +783,12 @@
   {"requestedDepth", "RequestedDepth", XtRInt, sizeof(int),
    XtOffsetOf(AppData, requestedDepth), XtRImmediate, (XtPointer) 0},
 
-  {"useSharedMemory", "UseSharedMemory", XtRBool, sizeof(Bool),
+  {"useShm", "UseShm", XtRBool, sizeof(Bool),
    XtOffsetOf(AppData, useShm), XtRImmediate, (XtPointer) True},
 
+  {"termChat", "TermChat", XtRBool, sizeof(Bool),
+   XtOffsetOf(AppData, termChat), XtRImmediate, (XtPointer) False},
+
   {"wmDecorationWidth", "WmDecorationWidth", XtRInt, sizeof(int),
    XtOffsetOf(AppData, wmDecorationWidth), XtRImmediate, (XtPointer) 4},
 
@@ -191,6 +798,9 @@
   {"popupButtonCount", "PopupButtonCount", XtRInt, sizeof(int),
    XtOffsetOf(AppData, popupButtonCount), XtRImmediate, (XtPointer) 0},
 
+  {"popupButtonBreak", "PopupButtonBreak", XtRInt, sizeof(int),
+   XtOffsetOf(AppData, popupButtonBreak), XtRImmediate, (XtPointer) 0},
+
   {"debug", "Debug", XtRBool, sizeof(Bool),
    XtOffsetOf(AppData, debug), XtRImmediate, (XtPointer) False},
 
